#!/bin/bash
#MENU=Post installation pour CCS
echo "CCS : application des droits version 2 du 13/02/2006"

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=ccs,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe ccs"
		/usr/share/eole/backend/ajout_groupe.py ccs
fi

echo "permissions  du dossier commun"
/usr/bin/setfacl -k --set user::rwx,group::r-x,other::r-x /data/applidos/commun


echo "permissions  du dossier commun/ccs"
/usr/bin/setfacl -m user::rwx,group::r-x,group:ccs:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:mask::rwx,default:other::r-- /data/applidos/commun/ccs


echo "permissions du dossier et des sous-dossiers commun/ccs/fichiers"
for fic in `find /data/applidos/commun/ccs/fichiers`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ccs:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/ccs/logiciel"
for fic in `find /data/applidos/commun/ccs/logiciel`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ccs:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:r-x,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/ccs/ccstmp"
for fic in `find /data/applidos/commun/ccs/ccstmp`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ccs:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:rwx,mask::rwx,other::r-- $fic
	fi

done

echo "permissions du fichier commun/ccs.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:r-x,mask::rwx,other::r-- /data/applidos/commun/ccs.bat 


echo "permissions du fichier commun/restccs.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:ccs:r-x,mask::rwx,other::r-- /data/applidos/commun/restccs.bat 

echo "CCS : application des droits terminée"

