#!/bin/bash
#MENU=Post installation pour CEC
echo "CEC : application des droits version 4 du 13/02/2006"

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=cec,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe cec"
		/usr/share/eole/backend/ajout_groupe.py cec
fi

echo "permissions  du dossier commun"
/usr/bin/setfacl -k --set user::rwx,group::r-x,other::r-x /data/applidos/commun


echo "permissions  du dossier commun/cec"
/usr/bin/setfacl -m user::rwx,group::r-x,group:cec:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:mask::rwx,default:other::r-- /data/applidos/commun/cec


echo "permissions du dossier et des sous-dossiers commun/cec/fichiers"
for fic in `find /data/applidos/commun/cec/fichiers`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:cec:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:cec:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:cec:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/cec/logiciel"
for fic in `find /data/applidos/commun/cec/logiciel`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:cec:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:cec:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:cec:r-x,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/cec/cectmp"
for fic in `find /data/applidos/commun/cec/cectmp`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:cec:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:cec:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:cec:rwx,mask::rwx,other::r-- $fic
	fi

done

echo "permissions du fichier commun/cec.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:cec:r-x,mask::rwx,other::r-- /data/applidos/commun/cec.bat 


echo "permissions du fichier commun/restcec.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:cec:r-x,mask::rwx,other::r-- /data/applidos/commun/restcec.bat 

echo "CEC : application des droits terminée"

