#!/bin/bash
#MENU=Post installation pour GFCDOS
echo "GFCDOS: application des droits version 4 du 13/02/2006"

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=gfc,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe gfc"
		/usr/share/eole/backend/ajout_groupe.py gfc
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=adage,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe adage"
		/usr/share/eole/backend/ajout_groupe.py adage 
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=bud,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe bud"
		/usr/share/eole/backend/ajout_groupe.py bud
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=cofi,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe cofi"
		/usr/share/eole/backend/ajout_groupe.py cofi
fi


if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=compta,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe compta"
		/usr/share/eole/backend/ajout_groupe.py compta
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=ordo,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe ordo"
		/usr/share/eole/backend/ajout_groupe.py ordo
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=phobos,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe phobos"
		/usr/share/eole/backend/ajout_groupe.py phobos
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=regie,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe regie"
		/usr/share/eole/backend/ajout_groupe.py regie
fi

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=verif,ou=local,ou=groupe'`" ] ; then 
	echo "Ajout du groupe verif"
	/usr/share/eole/backend/ajout_groupe.py verif
fi

echo "permissions  du dossier commun"
/usr/bin/setfacl -k --set user::rwx,group::r-x,other::r-x /data/applidos/commun


echo "permissions du dossier  comgfc"
/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:r-x,group:compta:r-x,group:bud:r-x,group:cofi:r-x,group:adage:r-x,group:phobos:r-x,group:verif:rwx,group:regie:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ordo:r-x,default:group:compta:r-x,default:group:bud:r-x,default:group:cofi:r-x,default:group:adage:r-x,default:group:phobos:r-x,default:group:verif:r-x,default:group:regie:r-x,default:mask::rwx,default:other::r-- /data/applidos/comgfc 

echo "permissions du dossier et des sous-dossiers comgfc/gfc"
for fic in `find /data/applidos/comgfc/gfc`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:rwx,group:compta:rwx,group:regie:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ordo:rwx,default:group:compta:rwx,default:group:regie:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:rwx,group:compta:rwx,group:regie:rwx,mask::rwx,other::r-- $fic
	fi

done

echo "permissions du dossier et des sous-dossiers comgfc/n-1"
for fic in `find "/data/applidos/comgfc/n-1"`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:cofi:rwx,group:compta:rwx,group:ordo:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:cofi:rwx,default:group:compta:rwx,default:group:ordo:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:cofi:rwx,group:compta:rwx,group:ordo:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers comgfc/verif"
for fic in `find /data/applidos/comgfc/verif`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:bud:rwx,group:cofi:rwx,group:compta:rwx,group:ordo:rwx,group:regie:rwx,group:verif:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:bud:rwx,default:group:cofi:rwx,default:group:compta:rwx,default:group:ordo:rwx,default:group:regie:rwx,default:group:verif:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:bud:rwx,group:cofi:rwx,group:compta:rwx,group:ordo:rwx,group:regie:rwx,group:verif:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers comgfc/phobos"
for fic in `find /data/applidos/comgfc/phobos`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:rwx,group:phobos:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ordo:rwx,default:group:phobos:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:rwx,group:phobos:rwx,mask::rwx,other::r-- $fic
	fi

done



echo "permissions du dossier et des sous-dossiers commun/np1"
for fic in `find /data/applidos/comgfc/np1`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:bud:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:bud:rwx,default:mask::rwx,default:other::r-- $fic


	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:bud:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/adage"
for fic in `find /data/applidos/comgfc/adage`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:adage:rwx,group:compta:rwx,group:ordo:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:adage:rwx,default:group:compta:rwx,default:group:ordo:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:adage:rwx,group:compta:rwx,group:ordo:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du fichier comgfc/gfc/gfcfin.exe"
/usr/bin/setfacl -m user::rwx,group::r--,group:ordo:r-x,mask::rwx,other::r-- /data/applidos/comgfc/gfc/gfcfin.exe 

echo "permissions du fichier comgfc/n-1/gfc/gfcfin.exe"
/usr/bin/setfacl -m user::rwx,group::r--,group:compta:r-x,mask::rwx,other::r-- /data/applidos/comgfc/n-1/gfc/gfcfin.exe

echo "permissions du fichier comgfc/n-1/gfc/gfcg.exe"
/usr/bin/setfacl -m user::rwx,group::r--,group:compta:r-x,mask::rwx,other::r-- /data/applidos/comgfc/n-1/gfc/gfcg.exe

echo "permissions du fichier comgfc/gfc/gfcreg.exe"
/usr/bin/setfacl -m user::rwx,group::r--,group:regie:r-x,mask::rwx,other::r-- /data/applidos/comgfc/gfc/gfcreg.exe 

echo "permissions du fichier comgfc/n-1/gfc/gfccf.exe"
/usr/bin/setfacl -m user::rwx,group::r--,group:cofi:r-x,mask::rwx,other::r-- /data/applidos/comgfc/n-1/gfc/gfccf.exe

echo "GFCDOS: application des droits terminée"

