<?
/*
=======================================================================

   module de fonctions génériques 
   $Id: common-lib.inc,v 1.1.1.1 2004/01/05 10:25:51 eole Exp $
=======================================================================
-
 utilitaires divers (lire et écrire dans un fichier,
 et toute autre fonctionnalité globalement utilisable) 
-
 Fonctions : 

 String2File
 File2String
 Add2File
 Explose_Fichier
 getScriptName
 PrintDate
 l
 ReplaceKeyWord
 Generate
 create_file
 delete_file
 get_dir
 
-
 Remarques :

 franciser les noms de fichiers
 

/*
=======================================================================

 manipulation de fichier

=======================================================================
*/

  /*
    String2File
    -
    met une chaine de caractères dans un fichier
    -
    Paramètres :
    $buffer : la chaine de caractères
    ,$file : le fichier à écraser
    -
    Résultat :
    rien
    -
    Globales :
    $error_log_warning
    - 
  */


function String2File($buffer,$file)
{

  //écriture dans un fichier

  global $error_log_warning ;

    if (file_exists($file)) {

      // ouverture du fichier en écriture seule, pointeur en tete du fichier
            $file_handler = fopen($file,'w') ;
            // le fichier existe,ouverture
	    fwrite($file_handler,$buffer) ;
	    fclose($file_handler) ;

            } else { // le fichier n'existe pas

	      $error_message = PrintDate() ;
	      $error_message .= "fichier $file introuvable ! écriture stoppée";
	      l($error_message,$error_log_warning) ;

	      exit();

            } // le else permet d'éviter une création automatique de fichier
}

/*

File2String
-
lit un fichier et met le contenu dans une variable
-
Paramètres
$file : nom du fichier à lire
-
Résultat
string : renvoie le contenu du fichier 
-
Globales
$error_log_warning

*/
function File2String($file) 
{

  // lecture dans un fichier

  global $error_log_warning ;

    if (file_exists($file)) {

      $buffer = implode("",file($file)) ;
      // le fichier existe,ouverture

      return $buffer ;
      // renvoie le contenu du fichier

    } else { // le fichier n'existe pas...

      $error_message = PrintDate() ;
      $error_message .= "fichier $file introuvable ! importation stoppée";
      l($error_message,$error_log_warning) ;

      exit();

      // ... et stopper carrement le programme
    } 

}

/*
Add2File
-
ajoute une chaine de caractère à la fin d'un fichier
-
Paramètres 
$buffer string : la chaine à ajouter
$file : le fichier à implémenter
-
Globales 
$error_log_warning ;
 */
function Add2File($buffer,$file) 
{

  global $error_log_warning ;

    if (file_exists($file)) {

      // ouverture du fichier en écriture seule, pointeur en fin de fichier
            $file_handler = fopen($file,'a') ;
            // le fichier existe,ouverture
	    fwrite($file_handler,$buffer) ;
	    fclose($file_handler) ;

            } else { // le fichier n'existe pas

	    $error_message = PrintDate() ;
	    $error_message .= "fichier $file introuvable ! écriture stoppée";
	    l($error_message,$error_log_warning) ;
            exit();

            } // le else permet d'éviter une création automatique de fichier

}

function Explose_Fichier ( $nom_fichier )
{

  // identique à la fonction file() mais avec une gestion d'erreur
  // renvoie false en cas d'échec

  global $error_log_warning ;

    if ( file_exists ( $nom_fichier ) ) {

      $vecteur = file( $nom_fichier ) ;

      // test du contenu du de ce ce qui a été explosé

      if ( is_array ( $vecteur ) )   
	{

	  return $vecteur ;

	} else  
	  {

	    return FALSE ;

	  }


    } else { 

      // le fichier n'existe pas => compte-rendu

      $error_message = PrintDate() ;
      $error_message .= "fichier $nom_fichier introuvable ! lecture stoppée";

      l($error_message,$error_log_warning) ;

      return FALSE ;

    }


}


/*
=======================================================================

utilitaires divers

=======================================================================
*/

// donne le nom de fichier (sans l'extension)
function getScriptName() {
  
  global $PHP_SELF ;

  //  $fichier = ExtensionCut(basename($PHP_SELF)) ;
  $fichier = basename($PHP_SELF) ;
  $nom_fichier  = array_shift(explode(".", $fichier));  

  return $nom_fichier ;

} 

function PrintDate()  {

  // sortie d'une date formatée 
  // parce qu'on est pas des machine à lire les time stamps...
  
  $msg = "\n" ;
  $now = time() ;

  $msg .= date(" j/m/Y, H:i:s ",$now) ;

  $msg .= "\n" ;

  return $msg ;

}

// generation de logs dans un fichier
function l($msg,$log_type)  {

  global $path_log ;

  $log_file = $path_log.$log_type ;
  error_log ($msg,3,$log_file) ;		
  
}

/*
=======================================================================

generateur pour la gestion des templates

=======================================================================
*/


function ReplaceKeyWord(
		    $word_search
		    ,$word_replace
		    ,$buffer
		    )
{

// fonction remplacement des mots clefs

   if ( ereg( "$word_search", $buffer ) ) {
     $motif = "\{".$word_search."\}" ;
     $buffer = ereg_replace($motif, $word_replace, $buffer) ;
  }
   return $buffer ;
}


function Generate(
		  $key_word
		  ,$template_file
		  ) {

// utilitaire de génération

  reset($key_word) ;
  $buffer = File2String($template_file) ;
  
  foreach ($key_word as $key => $val ) {
    
    $buffer = ReplaceKeyWord(
			     $key
			     ,$val
			     ,$buffer
			     ) ;
  }
  return $buffer ;
}

/*
=======================================================================

fonctions diverses de la naat-lib

=======================================================================
*/
// TODO : pas utilisé pour l'instant

//	 create a file like stack
  function create_file ($file)
  {
    if ( !file_exists ($file) ) 
      {
	$status_file =  fopen ($file, 'w+');
	chmod ($file, 0600);
      } 
    else 
      {
	$status_file =  fopen ($file, 'r');
      }
    return $status_file;
  }

//	delete a file
  function delete_file ($file)
  {
    if ( file_exists ($file) ) 
      { 
	return unlink($file);
      }
    return 0;
  }

/*
=======================================================================

fonctions pour les scripts personnalisés

=======================================================================
*/

function get_dir($rep)
{

  // lit le contenu d'un répertoire donné
  // et retourne un vecteur contenant la liste des fichiers

	$handle=opendir($rep); 
	while ($fic = readdir($handle))
	{ 
		if ($fic=="." or $fic=="..")
		{ 
			next;
		}
		else
		{ 
			$tabFichiers[]="$fic"; 
		} 
	}
	if($tabFichiers)
	{
		rsort ($tabFichiers);
		return $tabFichiers;
	}
	else
	{
		return false ;
	}
}
/*
-
create_FileID
-
crée un fichier temporaire specifique a l'ID de l'utilisateur
-
Paramètres :
pas de paramètres
-
Globales :
PHPSESSIPD: la variable de session
*/

function create_FileID ()
{

  global $PHPSESSID , $temp_path ; 

  $name_FileID = "File_ID_".$PHPSESSID ;

  $str_buffer = $temp_path.$name_FileID ;

  `touch $str_buffer` ;

  return $str_buffer ;

}



function create_FileIDGrep ()
{

  global $PHPSESSID , $temp_path ; 

  $name_FileID = "File_ID_Grep".$PHPSESSID ;

  $str_buffer = $temp_path.$name_FileID ;

  `touch $str_buffer` ;

  return $str_buffer ;

}







?>