<?

include_once 'config-ldap.php';

// connexion à l'annuaire
function connexion_ldap()
{
   // très important !
   global $ldap_server,$ldap_port,$ldap_binddn,$ldap_bindpw;
   
   $ds=ldap_connect($ldap_server,$ldap_port);
   if ($ds!=1)
   {
      // php bind en ldap v2 par defaut !
      ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
      $r=ldap_bind($ds); //,$ldap_binddn);//,$ldap_bindpw);
   }
   else {
      echo  "Impossible de se connecter au serveur LDAP";
   exit;
   }

   return($ds);
}
 

// nombre d'entrées de type truc
function count_local($truc)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=$truc,$racine";
   $filtre="(objectClass=*)";
   $sr = ldap_search($ds,$dn,$filtre);
   $nb=ldap_count_entries($ds,$sr)-1;
   ldap_close($ds);
   return($nb);
}


// existance d'une entrée machin de type truc
function existe($machin,$truc)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=$truc,$racine";
   $filtre="(cn=$machin)";
   $sr = ldap_search($ds,$dn,$filtre);
   $info = ldap_get_entries($ds, $sr);
   ldap_close($ds);
   if ( $info[0] == ''){
      return (0);
   }
   else{
      return (1);
   }
}


// existance d'un compte machine
// on peut pas utiliser la précédente à cause du "local"
function existe_compte($compte)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=ordinateurs,ou=ressources,$racine";
   $filtre="(cn=$compte)";
   $sr = ldap_search($ds,$dn,$filtre);;
   $info = ldap_get_entries($ds, $sr);
   ldap_close($ds);
   if ( $info[0] == ''){
      return (0);
   }
   else{
      return (1);
   }
}


// liste des groupes (select)
// le groupe $vainqueur est selectionné
function list_groupes($vainqueur)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=groupes,$racine";
   $filtre="(&(objectClass=posixGroup)(!(cn=DomainComputers)))";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"cn");
   $info = ldap_get_entries($ds, $sr);
   //$gbuf="<select name='groupe' size=1 >";
   for ($i=0; $i<$info["count"]; $i++){
      $groupe= $info[$i]["cn"][0];
      $gbuf.="<br><option value=$groupe ";
      if ($groupe==$vainqueur) $gbuf.= " selected ";
      $gbuf.="> $groupe </option>";
   }
   //$gbuf.= "</select>";
   ldap_close($ds);
   return($gbuf);
}


// liste des groupes existants en-dehors de ceux de la liste
function hors_groupes($liste)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=groupes,$racine";
   $filtre="(&(objectClass=posixGroup)(!(cn=DomainComputers)))";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"cn");
   $info = ldap_get_entries($ds, $sr);
   for ($i=0; $i<$info["count"]; $i++){
      $groupe= $info[$i]["cn"][0];
      if (! (in_array($groupe,$liste))) {
        $out[]=$groupe;
      }
   }
   ldap_close($ds);
   return($out);
}


// liste des utilisateurs
// $forme = 'checkbox' ou 'select')
// le vainqueur est séléctionné
function list_users($forme,$vainqueur)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=personnels,ou=utilisateurs,$racine";
   $filtre="(objectClass=inetOrgPerson)"; // si pb mettre 
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"cn");
   $info = ldap_get_entries($ds, $sr);
   //$selbuf="<select name='user' size=1 >";
   for ($i=0; $i<$info["count"]; $i++){
      $user= $info[$i]["cn"][0];
      $selbuf.="<br><option value=$user";
      if ($user==$vainqueur) $selbuf.=' selected ';
      $selbuf.="> $user </option>";
      $checkbuf.="<input type='checkbox' name= test[$i] value='$user'> $user <br>";
   }
   //$selbuf.= "</select>";
   ldap_close($ds);
   if ($forme=='checkbox') {
      return ($checkbuf);
   }
   else {
      return ($selbuf);
   }
}


// liste des utilisateurs appartenant au groupe $groupe (coché)
// ou NON (décoché)
function utilisateurs_du_groupe($groupe)
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=personnels,ou=utilisateurs,$racine";
   $filtre="(objectClass=inetOrgPerson)";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"cn");
   $info = ldap_get_entries($ds,$sr);
   $membres = membres($groupe);
   for ($i=0; $i<$info["count"]; $i++){
      $user= $info[$i]["cn"][0];
      $checkbuf.="<input type='checkbox' name=test[$i] value=on";
      if (in_array($user,$membres)) $checkbuf.=" checked ";
      $checkbuf.="> $user <br>";
      // ajout du champ caché contenant le nom de l'utilisateur
      $checkbuf.="<input type=hidden name=util[$i] value='$user'>";
   }
   ldap_close($ds);
   return ($checkbuf);
}


// retourne la liste des partages 
// sous forme de balises option
// avec possibilité de présélection
function list_partages($preselect="")
{
   // très important !
   global $racine;
   $ds=connexion_ldap();
   $dn = "ou=local,ou=partages,$racine";
   $filtre="(objectClass=sambaFileShare)";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"description");
   $info = ldap_get_entries($ds, $sr);
   for ($i=0; $i<$info["count"]; $i++){
      $share= $info[$i]["description"][0];
      if ($share==$preselect) $buf.="<option value=$share selected>$share</option>";
      else $buf.="<option value=$share>$share</option>";
   }
   ldap_close($ds);
   return($buf);
}


function list_comptes()
{
   // très important !
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=ordinateurs,ou=ressources,$racine";
   // à cet endroit sont stockés le serveur et les éventuelles stations
   $filtre="(|(objectClass=sambaServer)(objectClass=sambaSamAccount))";
   $sr = ldap_search($ds,$dn,$filtre);
   ldap_sort($ds,$sr,"cn");
   $info = ldap_get_entries($ds, $sr);
   for ($i=0; $i<$info["count"]; $i++){
      $stat= $info[$i]["cn"][0];
      $buf.="<br><option value=$stat>$stat</option>";
   }
   ldap_close($ds);
   return($buf);
}


// renvoi la valeur de l'attribut $attribut pour l'utilisateur $user
function get_value($attribut,$user)
{
   // très important !
   global $racine;
   $ds=connexion_ldap();
   $dn = "ou=local,ou=personnels,ou=utilisateurs,$racine";
   $filtre="(&(objectClass=inetOrgPerson)(uid=$user))";
   $sr = ldap_search($ds,$dn,$filtre);
   $info = ldap_get_entries($ds, $sr);
   if ($info["count"]==1) {
      return ($info[0][$attribut][0]);
   }
   return "";
}   
   

// renvoi le nom du partage qui a réservé la lettre $lettre
// ou "" si la lettre n'est pas reservée
function reservee($lettre)
{
   $tab=explode("\n",`/usr/share/eole/backend/manage_special_shares.py`);
   $size=(count($tab));
   for ($i=0;$i<$size;$i++) {
      if (preg_match("/^$lettre/",$tab[$i])) {
         $t=explode(" ",$tab[$i]);
	 return $t[1];
      }
   }
   return "";
}

// retourne la liste des membres du groupe $groupe 
// dans un tableau ou un tableau vide
function membres($groupe) {
   
   global $racine;
   
   $ds=connexion_ldap();
   $dn = "ou=local,ou=groupes,$racine";
   $filtre="(cn=$groupe)";
   $sr = ldap_search($ds,$dn,$filtre);
   $membres = ldap_get_entries($ds,$sr);
   // groupe vide
   if (! (is_array($membres[0]['memberuid']))) return (array());
   // groupe non vide (supprimer l'entrée "count")
   $membres=$membres[0]['memberuid'];
   array_shift($membres);
   return($membres);
}


?>
