<?

require('CAbstractPage.php');

// =====================================================
// class BasePage
// =====================================================
class CBasePage extends CAbstractPage {

	var $m_oTplNavigation;
	var $m_arColors;
	var $m_bAdministratorPage;

	function CBasePage($p_sNavigation,$p_sName,$p_sTemplate)
	{
		// Initialization 
		$this->CAbstractPage($p_sNavigation,$p_sName,$p_sTemplate);
		$this->m_sTemplate=$p_sTemplate;

		// Create the navigation template
		$this->m_oTplNavigation=new CAbstractPage('','','tpl_navigation.htm');
		
		$this->m_arColors["PAIR"][0]="FFFFCC";$this->m_arColors["PAIR"][1]="CCFFCC";
		$this->m_arColors["IMPAIR"][0]="FFFFAA";$this->m_arColors["IMPAIR"][1]="CCF1DA";
		
		$this->m_bAdministratorPage=false;
	}
	
	function GetColumnColor($p_sColumn,$p_iLine)
	{
		return $this->m_arColors[$p_sColumn][$p_iLine];
	}
	
	function AssignColorForCurrentLine($p_iLine)
	{
		$this->assign("COLOR",$this->GetColumnColor("PAIR",$p_iLine));
		$this->assign("COLOR_IMPAIR",$this->GetColumnColor("IMPAIR",$p_iLine));
		$this->assign("COLOR_PAIR",$this->GetColumnColor("PAIR",$p_iLine));
	}
	
	// Function : DrawNavigation
	// Draw the navigation toolbar
	function DrawNavigation()
	{
		 // ---
		 $this->m_oTplNavigation->parse("main.DebutNavigation");
		 
		 // ---
		 $arLiens=explode(",",$this->m_sNavigation);
		 reset ($arLiens);
	 	 while (list ($key, $val) = each ($arLiens)) 
	 	 {
		 	if ($val=="") continue;
			list ($liens,$text,$target) = explode("@",$val);
			$this->m_oTplNavigation->assign("liens",$liens);
		    $this->m_oTplNavigation->assign("text",$text);
		    $this->m_oTplNavigation->assign("target",$target);
			$this->m_oTplNavigation->parse("main.link");	
		 }
		 
		 $this->m_oTplNavigation->assign("text",$this->m_sName);
		 $this->m_oTplNavigation->parse("main.titre");

		 // ---
		 $this->m_oTplNavigation->parse("main.FinNavigation");
	}
	
	// Function : DrawHeader
	// Draw the header of the page
	function DrawHeader()
	{
		$this->m_oTplNavigation->parse("main.header");
	}
	
	// Function : DrawFooter
	// Draw the footer of the page
	function DrawFooter()
	{
		$this->m_oTplNavigation->parse("main.footer");
		$this->m_oTplNavigation->out("main.footer");
	}
	
	// Function : DrawCore
	// draw the core of the page
	// Must be overwided to draw the owner page
	function DrawCore()
	{
		
		echo "<br>";
		echo "OVERWRIDE THIS METHOD TO DRAW THE CORE";
		echo "<br>";
	}
	
	function DrawAccess()
	{
		echo "<br>";
		echo "ACCES REFUSE ";
		echo "<br>";
	}
	
	function Draw()
	{
		$this->DrawHeader();
		$this->DrawNavigation();
		$this->m_oTplNavigation->parse("main");
		$this->m_oTplNavigation->out("main");
		
		if (($this->m_bAdministratorPage) && (!$this->isAdministrator())) 
			$this->DrawAccess();
		else
			$this->DrawCore();
			
		$this->DrawFooter();
	}

	function  SetAdministratorPage($p_bSet)
	{
		$this->m_bAdministratorPage=$p_bSet;
	}

}

?>