<?

require('CBasePage.php');
require('CSmbStatus.php');
require('CToolbar.php');
require('../libs/ldap.php');
 
class CMainFrame extends CBasePage
{
	var $m_arUserPid;
	var $m_oSmbStatus;
	var $m_iMaxFilesToDisplay=5;
	
	function CMainFrame()
	{
		$this->CBasePage('../../index.php@Home@_top',
						 'Gestionnaire de connections',
						 'tpl_mainframe.htm');
		
		$this->m_oSmbStatus=new CSmbStatus();
		$this->m_oToolbar=new CToolbar();
	
	}
	
	// -------------------------------------------------------------------------
	// Function : DrawToolBar
	function DrawToolbar()
	{

		$count=$this->m_oSmbStatus->GetNumberOfConnectedUser();
					
		// Button : [Arreter/Activer][Login] [Deconnecter] available only in the administrator mode					 
		if ($this->isAdministrator())
		{
		
			if (ServiceIsStarted())
			{
				$this->m_oToolbar->AddButtonTool("CStopPage.php",
												"Arrêter","arreter.gif",
												"<img src=../image/login_arreter.gif >Désactive tous les logins et <br>\
												&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src=../image/supprimer.gif>Déconnecte tous les utilisateurs\
												");
			}
			else
			{
				$this->m_oToolbar->AddButtonEx("../scripts/start.php@Activer@restart.gif@Autoriser tous les utilisateurs à pouvoir se connecter@BOTTOM_FRAME");
			}
				
			if ($count!=0)						 
				$this->m_oToolbar->AddButtonTool("javascript:Deconnecter();",
											 	"Déconnecter","deconnecter.gif",
											 	"Permet de déconnecter les utilisateurs sélectionnés <br>\
											 	<i><u>Note :</u></i>  La selection se fait par les <br>\
											 	cases à cocher dans la colone <b><i>Actions</i></b>");																 
											 
		}
		
		if ($count != 0) 
			$this->m_oToolbar->AddButtonTool("javascript:SendMessage();",
										 	"Message",
										 	"mail.gif",
										 	"Permet d\'envoyer un message<br>aux utilisateurs sélectionnés.<br>\
										 	<i><u>Note :</u></i>  La selection se fait par les <br>\
										 	cases à cocher dans la colone <b><i>Actions</i></b>");
		
		if ($this->isAdministrator())
		{
			$this->m_oToolbar->AddButtonTool("CLoginPage.php",
										 	"Login","login.gif",
										 	"Affiche la page pour la gestion des logins");
		}
		
		$this->m_oToolbar->AddButtonTool("CQuotaPage.php",
										"Quotas",
										"quota.gif",
										"Affiche le bilan de l\'espace disque utilisé");
		
		// CL : 02/06/2004 Ajout du button Machine
		$this->m_oToolbar->AddButtonTool("CMachines.php",
										"Machines",
										"machines.gif",
										"Recherche des stations connectées au réseau");
				
		$this->m_oToolbar->AddButtonTool("javascript:Refresh();",
										"Actualiser",
										"refresh.gif",
										"Actualise la page");
		
		
		$this->m_oToolbar->Draw();
	}
	// ---------------------------------------------------------------------------
	
	// ---------------------------------------------------------------
	// function : DrawConnectedUsers
	// Draw the connected users
	function DrawConnectedUsers()
	{
		$array=$this->m_oSmbStatus->GetArrayUser();
		if ($array==false) 
		{
			$this->assign("NUMBER",0);
			$this->parseout("main.connection");return;
		}
	
		$this->assign("NUMBER",count($array));
		//$this->parseout("main.connection.debut");
		
		// Display the list of connected users
		$count=0;
		while (list ($user, $val) = each ($array)) 
		{
			$this->assign("user",$user);
			$this->assign("NEWLINE","");
			$count++;
			if ($count>4) {
				$this->assign("NEWLINE","\n</tr>\n<tr>");
				$count=0;
			} 
			if (!$this->m_oSmbStatus->HasApplications($user)) 	
				$this->parse("main.connection.user");
			else
			    $this->parse("main.connection.userbold");
				
					
		}
		//$this->out("main.connection.user");
		
		$this->parse("main.connection");
		$this->out("main.connection");
	}
	// ----------------------------------------------------------------
	
	// -----------------------------------------------------------------
	function DrawApplicationsForUser($p_sUser,$p_sComputer,$p_bFirst)
	{
		$array=$this->m_oSmbStatus->GetApplicationsForUser($p_sUser,$p_sComputer);
		// Array is empty, do nothing and return
		if (!is_array($array) || (count($array)<=0) ) return false;
		
		if ($p_bFirst) $this->parseout("main.border_applications");
		
		$this->parseout("main.application");
		while (list ($key, $oAppsInfo) = each ($array)) 
		{
			$oAppsInfo->Assign($this);
			if ($oAppsInfo->GetCount()<=1)
			{
				$this->parseout("main.application_boucle_once");
			} else
			{
				$this->parseout("main.application_boucle_multiple");
			}
		}
		return count($array)>0;
	}
	// -----------------------------------------------------------------
	
	// -----------------------------------------------------------------
	function DrawFilesForUser($p_sUser,$p_sComputer,$p_bHasApplication,$p_bFirstComputer)
	{
	
		$array=$this->m_oSmbStatus->GetFilesForUser($p_sUser,$p_sComputer);
		if (!is_array($array) ||  (count($array)<=0) ) return false;
		
		$bDisplayMore=(count($array)>$this->m_iMaxFilesToDisplay);
		$iCurrentLine=0;
		
		if ((!$p_bHasApplication) && $p_bFirstComputer) $this->parseout("main.debut_details");
		
		if ($bDisplayMore) $this->parse("main.file.displayMore");
		
		$this->reset("main.file");
		$this->parse("main.file");
		$this->out("main.file");
		
		while (list ($index, $oFilesInfo) = each ($array)) 
		{
			// Filter to display only .dbf and .exe
			// if ((strpos($key,".dbf")=== false)  && (strpos($key,".exe")=== false)) continue;
			if ($iCurrentLine>= $this->m_iMaxFilesToDisplay)  break;
		
			$iCurrentLine++;
			$oFilesInfo->Assign($this);
			
			if ($oFilesInfo->GetCount()<=1)
				$this->parseout("main.file_boucle_once");
			else
				$this->parseout("main.file_boucle_multiple");
		}
		return count($array)>0;
	}
	// -----------------------------------------------------------------	
	
	// -----------------------------------------------------------------
	// function : DrawDetails
	function DrawDetails()
	{
		$this->parseout("main.debut");
		
		$iLine=0;
		$array=$this->m_oSmbStatus->GetArrayUser();
		if (!is_array($array)) return;
		while (list ($user, $val) = each ($array)) 
		{
			// Initialize Color, and username
			$iLine= ($iLine+1) % 2;
			$this->AssignColorForCurrentLine($iLine);
			
			
			$this->assign("USER",$user);
			$this->assign("COMPUTERS",$this->m_oSmbStatus->GetComputersForUser($user));
			
			// Retrieve all computers where the user is connected to
			$listComputers=$this->m_oSmbStatus->GetArrayOfComputersForUser($user);
			$bFirst=true;
			$bApp=false;
			$bFile=false;
			if ($this->isAdministrator()) $this->parse("main.user.deconnecter");
			$this->parseout("main.user");
			//$this->out("main.user");
		
			while (list ($iIndex, $sComputer) = each ($listComputers)) 
			{
				if (trim($sComputer)=="") continue;
				
				$this->assign("COMPUTER",$sComputer);
				$this->assign("IP",$this->m_oSmbStatus->GetIP($sComputer));
		
				if ($bFirst) 
				{
					$this->parseout("main.computerFirst");
				}
				else
				{
					$this->parseout("main.computerOther");	
				}
				
				$bApp  = $this->DrawApplicationsForUser($user,$sComputer,$bFirst) || $bApp ;
				$bFile = $this->DrawFilesForUser($user,$sComputer,$bApp,$bFirst) || $bFile ;
				$bFirst=false;
		
			}; // END WHILE COMPUTER
			
			if ($bApp || $bFile)
				$this->parseout("main.fin_details");
					
		}; // END WHILE USER
		
		
		$this->parseout("main.fin");
	}
	// ----------------------------------------------------------------
	
	
	
	function DrawCore()
	{
		$this->DrawToolbar();
		$this->DrawConnectedUsers();
		$this->DrawDetails();

	}
	

}


$page = new CMainFrame();
$page->Draw();




?>
