<?
/*
======================================================================================================

module de génération des boutons dynamiques des scripts perso

=======================================================================================================

-
Ce module permet la génération des images des boutons, d'ajouter des sripts personnalisés à l'interface de gestion des scripts, de sérialiser et de déserialer les données du fichier serialize_btn.srz
-

Fonctions:

Image_Script
genrateTab
AjouterScript
Serialize_btn
deserialize_btn

-

Remarques:  
Les fonctions de sérialisations sont à normaliser

=======================================================================================================
*/

// NOMBRE MAXIMUM de SCRIPTS à GERER (nombre PAIR)
$max_scripts=12;

// INDEX LE PLUS HAUT 
$max_index=$max_scripts-1;

/*

Image_Script
-
Paramètres :
$string : libelle de l'image
-
Resultat:
Renvoie la balise htlm image qui se trouve dans $buffer
-
Globales:
pas de variables globales
-
*/


function Image_Script($string) 
{

  $libelle = urlencode($string) ;
  
  $url = "image.php?libelle=".$libelle ;
  
  $buffer = "" ;
  $buffer .= "<IMG NAME=\"script\" SRC=\"".$url."\" ALT=\"".$libelle."\" WIDTH=\"255\" HEIGHT=\"35\" BORDER=0>" ;
  
  return $buffer ;

}

/*
generateTab
-
Génère un tableau de 6 cellules, plus des images dynamiques suivant le nombre de scripts perso actifs
-
Parametres:
Pas de parametres
-
Resultat:
Retourne un tableau de 6 cellules, plus des images dynamiques suivant le nombre de script perso actifs
-
Globales:
Deserialize_btn()
Image_Script()
-
*/


function generateTab()
{
  global $max_index,$max_scripts;
  $result_vect = DeSerialize_btn() ;

 for ($ind=0; $ind<=$max_index; $ind++)
    {
      $tab_image[$ind] = "&nbsp;" ;
    }

// on va réutiliser ce vecteur, autant le réinitialiser...
 reset ($tab_image) ;

// incrémentation de l'indice de $tab_image
 $i = 0 ;

  if (is_array($result_vect))
    { 

	foreach ($result_vect as $clef => $valeur)
	{
	  // compteur d'incrémentation du tableau des image
	  
	  // faire une fonction qui génère les image

	  $string = $valeur['libelle'] ;
	  $script = $valeur['nom_script'] ;

	  $buffer = "<a href=\"result-script-perso.php?script=".$script."\">".Image_Script($string)."</a>" ;


	  $tab_image[$i] = $buffer ;
	  // incrémentation de l'indice de $tab_image
	  $i++ ;

	}
    
	$bugger = "<table>";

	// affichage en deux colonnes
	for ($i=0;$i<=$max_index;$i=$i+2) {
	   $j=$i+1;
	   $bugger .=  "<TR><TD>&nbsp;&nbsp;".$tab_image[$i]."</TD><TD>&nbsp;&nbsp;".$tab_image[$j]."</TD></tr>" ;
        }
	$bugger .= "</TABLE>" ;

	return $bugger ;

    }
}

/*
AjouterScript
-
ajoute un nouveau script (pour l'activer) au fichier contenant la liste des scripts perso actifs.
-
Paramètres:
$name_bouton_text: le nom du bouton ou libelle du bouton
$name_script_text: le nom du script a éxécuter quand on clique sur le bouton
-
Resultat:
retourne un message pour l'utilisateur
-
Globales:
btn_serialize: le fichier ou il y a les noms des scripts actifs
Deserialize_btn()
explose_Fichier()
Serialize_btn()
-
*/

function AjouterScript($name_bouton_text, $name_script_text)
{

  global $btn_serialize ;
  global $max_index,$max_scripts;

  if (($name_script_text != "") && ($name_bouton_text != "" ))
    
    {

      $vect_recup_script = Explose_Fichier( $btn_serialize ) ;

      $ind = count( $vect_recup_script ) ;
      
      $vect_btn = DeSerialize_btn() ;
       
      # passage à $max_scripts scripts MAXI
      if ($ind <= $max_index)
	{
	  if ($ind != 0)
	    {
	      $ind = $ind++ ;
	    }
	  
	  $vect_btn[] = array (
			       'nom_script' => $name_script_text
			       ,'libelle' => $name_bouton_text

			       ) ;
			   
	 
	  Serialize_btn($vect_btn) ;
	  
	  $afficher = "<p>votre script a bien été pris en compte</p>"  ; 
	  
	} else {
	  $afficher =  "<font color=red><b>Vous ne pouvez pas avoir plus de ".$max_scripts." scripts personnalisés
	  <br>actifs en même temps</b></font>" ;
	}  
  
    } else {

      $afficher = "vous devez remplir les deux champs texte" ;
    }

  return $afficher ; 
  
}

/*
Serialize_btn
-
serialise le contenu du vecteur $parse_btn dans le vecteur $ligne,
puis ecrit le contenu de $ligne dans le fichiers des scripts actifs
-
Parametres:
$parse_btn: un vecteur contenant le nom du script et le libelle du bouton
-
Resultat:
pas de resultat
-
Globales:
$btn_serialize: fichier ou il y a les scripts actifs (serialise_btn.srz)
String2File()
-
*/
function Serialize_btn( $parse_btn ) 
 
{
  
  global $btn_serialize ;

  $ligne = "" ;

  foreach ( $parse_btn as $clef => $val ) 
 
    {

      // 0: clef 1 : nom_script , 2 : libelle

      $ligne .= $clef."%%".$val['nom_script']."%%".$val['libelle']."\n" ;

    }

  String2File( $ligne , $btn_serialize ) ;

}

/*
Deserialize_btn
-
Split le contenu du vecteur pour separer les données
-
Paramatres:
Pas de parametres
-
Resultat:
retourne un vecteur avec le nom du script a exécuter et le libellé du bouton
-
Globales:
$btn_serialize: nom du fichier ou il y a les scripts actifs
Explose_Fichier()
-
*/


function DeSerialize_btn() 
 
{

  global $btn_serialize ;

  $lignes = Explose_Fichier ( $btn_serialize ) ;

  foreach ( $lignes as $val )
 
    {
      
      $v = split ("%%" ,$val) ;

      $v[2] = str_replace("\n","",$v[2]) ;

      $buffer = array( 
		      'nom_script' => $v[1]
		      ,'libelle' => $v[2]
				      ) ;
      $parse_r [$v[0]] = $buffer ;

    }

  return $parse_r ;

}

// liste des scripts (nom + libellé)
// contenu dans le répertoire des scripts
function listeScripts($rep)
{
   if (is_dir($rep)){
      $handle=opendir($rep);
      while ($file = readdir($handle)) {
         if ($file != "." && $file != "..") {
	    if (is_readable("$rep/$file")) {
	       $fp=fopen("$rep/$file","r");
	       if (!feof ($fp)) $ligne = trim(fgets($fp));
	       $lib=split("#MENU=",$ligne);
	       # menu en 1ere ligne
               if ($lib[1]) {
	          if ($lib[1] != "deprecated") {
		     $t_lib[$file]=$lib[1];
		  }
	       }
	       else {
                  if (!feof ($fp)) $ligne = trim(fgets($fp));
                  $lib=split("#MENU=",$ligne);
                  // menu en 2e ligne
                  if ($lib[1]) {
                     if ($lib[1] != "deprecated") {
                        $t_lib[$file]=$lib[1];
                     }
                  }else{
	             $t_lib[$file]="- fichier non conforme -";
                  }
	       }
	       fclose($fp);
	    }else{
	       $t_lib[$file]="- lecture du fichier impossible -";
	    }
	 }
      }
      closedir($handle);
   }
   return ($t_lib);
}   

//=======================================================================

?>
